unit Chart_pas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls, Menus,
  PngImage, HidUnit, MAHusb, FTPConfig, CalUnit, ComCtrls, Grids, ShellApi,
  Unit4, unit_DialogsEx, ShFolder, IniFiles, FileCtrl, LPControl,
  SLControlCollection, LPControlDrawLayers, LPTransparentControl,
  ULBasicControl, ILAnalogInstrument, ILAngularGauge, ILThermometer, Wunder,
  Slider, Language;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fi1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Hardwareinformation1: TMenuItem;
    FTPupload1: TMenuItem;
    Timer1: TTimer;
    Calibration1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Chart1: TChart;
    Label1: TLabel;
    Chart2: TChart;
    Label2: TLabel;
    LineSeries1: TLineSeries;
    StringGrid1: TStringGrid;
    N1: TMenuItem;
    EraseGraph1: TMenuItem;
    EraseList1: TMenuItem;
    Generalsettings1: TMenuItem;
    SaveList1: TMenuItem;
    SaveDialogEx1: TSaveDialogEx;
    SaveGraph1: TMenuItem;
    N2: TMenuItem;
    TabSheet3: TTabSheet;
    Pressure: TILAngularGauge;
    Temperature: TILAngularGauge;
    Panel1: TPanel;
    Panel2: TPanel;
    Temperature1: TILThermometer;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Slider1: TSlider;
    Slider2: TSlider;
    PressureArrow: TImage;
    TemperatureArrow: TImage;
    ArrowUp: TImage;
    ArrowRight: TImage;
    ArrowDown: TImage;
    WeatherUnderground1: TMenuItem;
    Taal1: TMenuItem;
    N3: TMenuItem;
    Nederlands1: TMenuItem;
    Engels1: TMenuItem;
    Files1: TMenuItem;
    N4: TMenuItem;
    SavePressureGraphas1: TMenuItem;
    SaveListas1: TMenuItem;
    SaveTemperatureGraphas1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Pauze1: TMenuItem;
    Meten1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Hardwareinformation1Click(Sender: TObject);
    procedure FTPupload1Click(Sender: TObject);
    procedure Calibration1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure EraseGraph1Click(Sender: TObject);
    procedure EraseList1Click(Sender: TObject);
    procedure Generalsettings1Click(Sender: TObject);
    procedure SaveList1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SaveGraph1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Slider1Change(Sender: TObject);
    procedure Slider1StartTracking(Sender: TObject);
    procedure Slider1StopTracking(Sender: TObject);
    procedure Slider2Change(Sender: TObject);
    procedure Slider2StartTracking(Sender: TObject);
    procedure Slider2StopTracking(Sender: TObject);
    procedure WeatherUnderground1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Nederlands1Click(Sender: TObject);
    procedure Engels1Click(Sender: TObject);
    procedure Files1Click(Sender: TObject);
    procedure SavePressureGraphas1Click(Sender: TObject);
    procedure SaveTemperatureGraphas1Click(Sender: TObject);
    procedure SaveListas1Click(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure Chart2DblClick(Sender: TObject);
    procedure Pauze1Click(Sender: TObject);
    procedure Meten1Click(Sender: TObject);
  private
    { Private declarations }
    MyHandle: THandle;
    NwChart : Boolean;
    DeviceString : String;
    FUsb : TUsbClass;
    procedure NewCharts;
    procedure GetOffsets;
    procedure GetCalibration;
    function  GetDeviceString: String;
    Procedure GetPressureAndTemperature(var Press: Double; var Temp: Double);
    Procedure GetAvgPressureAndTemperature(Times: Integer; var Press: Double; var Temp: Double);
    procedure UsbIN(ASender : TObject; const ADevType,ADriverName,
                    AFriendlyName, VID, PID : string);
    procedure UsbOUT(ASender : TObject; const ADevType,ADriverName,
                     AFriendlyName, VID, PID : string);
    function SaveAsExcelFile(AGrid: TStringGrid; AFileName: string): Boolean;
    Procedure SaveLabInstrumentAsPng(Instrument: TLPCustomControl; Fn: String);
  public
    { Public declarations }
    procedure SaveChartAsPng(Chart: TChart; Fn: String);
    function GetTempDirectory: String;
    procedure GridToCSV(Fn, Quote: String);
    procedure GridToText(Fn: String);
  end;

const Precision = 2;
      Version = '1.03';

var
  Form1: TForm1;
  AC1, AC2, AC3: SmallInt;                            // Cal. variables
  AC4, AC5, AC6: Word;                                // Cal. variables
  B1, B2, B5, MB, MC, MD: SmallInt;                   // Cal. variables
  Buf : Array [0..8] of Byte;                         // Read buffer
  AvgBuff: Array[0..4] of double;

  DataDir: String;
  IniDir : String;
  StartDate: String;

  OldPP: Double = 0;
  OldTT: Double = 0;

  ListSaveDir: String = '';
  PngSaveDir : String = '';

  bReadCal_1 : array[0..8] of Byte = (0, 1, $82, $77, $AA, 0, 0, 0, 0); // 8 Bytes
  bReadCal_2 : array[0..8] of Byte = (0, 1, $82, $77, $B2, 0, 0, 0, 0); // 8 Bytes
  bReadCal_3 : array[0..8] of Byte = (0, 1, $82, $77, $BA, 0, 0, 0, 0); // 8 Bytes
  bReadPress : array[0..8] of Byte = (0, 1, $84, $66,  0,  0, 0, 0, 0); // 8 Bytes
  bReadTemp  : array[0..8] of Byte = (0, 1, $80, $33,  0,  0, 0, 0, 0); // 8 Bytes
  bReadFlash : array[0..8] of Byte = (0, 1, $83, $77,  1,  0, 0, 0, 0); // 8 Bytes
  bWriteFlash: array[0..8] of Byte = (0, 1, $85, $11,  0,  0, 0, 0, 0); // 8 Bytes

implementation

{$R *.dfm}
{$R WINDOWSXP.RES}
{$R VERSION.RES}

function IntPower(Base: Extended; Exponent: Integer): Extended;
asm
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;

function RoundTo(const AValue: Double; const ADigit: Integer): Double;
var
  LFactor: Double;
begin
  LFactor := IntPower(10, ADigit);
  Result := Round(AValue / LFactor) * LFactor;
end;

{function SimpleRoundTo(const AValue: Double; const ADigit: Integer = -2): Double;
var
  LFactor: Double;
begin
  LFactor := IntPower(10, ADigit);
  Result := Trunc((AValue / LFactor) + 0.5) * LFactor;
end; }

Function Date2Str(n: TDateTime): String;
var D, M, Y: Word;
begin
  DecodeDate(n, Y, M, D);
  Result := IntToStr(D) + '-' + IntToStr(M) + '-' + IntToStr(Y);
end;

// ----------------------------------------------------------------------------
Function EncodePassWord(s: String): String;             // Password coderen
var i,n: Integer;
Begin
 Result:='';
 for n:=1 to Length(s) do
 begin
  i:=Ord(Copy(s,n,1)[1])+3+n;
  if i > 255 then i:=i-255;
  Result:=Result+Chr(i);
 end;
end;

// ----------------------------------------------------------------------------
Function DecodePassWord(s: String): String;             // Paasword decoderen
var i,n: Integer;
Begin
 Result:='';
 for n:=1 to Length(s) do
 begin
  i:=Ord(Copy(s,n,1)[1])-3-n;
  if i < 0 then i:=i+255;
  Result:=Result+Chr(i);
 end;
end;

// ----------------------------------------------------------------------------
Function CtoF(C: Double): String;
var D: Double;
begin
  D := C * 1.8 + 32;
  Result := StringReplace(FloatToStrF(D, ffFixed, 4, 2), ',', '.', [rfReplaceAll]);
end;

// ----------------------------------------------------------------------------
Function hPAtoBaromin(P: Double): String;
var D: Double;
begin
  D := 0.029534091313264401772525849335303 * P;
  Result := StringReplace(FloatToStrF(D, ffFixed, 6, 3), ',', '.', [rfReplaceAll]);
end;

// ----------------------------------------------------------------------------
Procedure TForm1.SaveLabInstrumentAsPng(Instrument: TLPCustomControl; Fn: String);
var BMP: TBitmap;
    PNG: TPNGObject;
begin
  BMP := TBitmap.Create;
  PNG := TPNGObject.Create;
  try
    BMP.Width  := Instrument.Width;
    BMP.Height := Instrument.Height;
    BMP.Transparent := True;
    Instrument.PaintTo(BMP.Canvas.Handle, 0, 0);
    PNG.Assign(BMP);
    PNG.SaveToFile(Fn);
  finally
    BMP.Free;
    PNG.Free;
  end;
end;

// ----------------------------------------------------------------------------
procedure TForm1.GridToCSV(Fn, Quote: String);
var y: Integer;
    f: TextFile;
    s: String;
begin
  try
    AssignFile(f, Fn);
    Rewrite(f);
    for y := 1 to StringGrid1.Rowcount - 1 do
    begin
      S := Quote + StringGrid1.Cells[0, y] + Quote + ',';
      S := S + Quote + StringGrid1.Cells[1, y] + Quote + ',';
      S := S + Quote + StringGrid1.Cells[2, y] + Quote + ',';
      S := S + Quote + StringGrid1.Cells[3, y] + Quote;
      WriteLn(f, s);
      Application.ProcessMessages;
    end;
    CloseFile(f);
  except
  //
  end;
end;

// ----------------------------------------------------------------------------
procedure TForm1.GridToText(Fn: String);
var f: TextFile;
    y: Integer;
    s: String;
begin
  try
    AssignFile(f, Fn);
    Rewrite(f);
    for y := 1 to StringGrid1.RowCount - 1 do
    begin
      S := StringGrid1.Cells[0, y] + Chr(9);
      S := S + StringGrid1.Cells[1, y] + Chr(9);
      S := S + StringGrid1.Cells[2, y] + Chr(9);
      S := S + StringGrid1.Cells[3, y];
      WriteLn(f, S);
      Application.ProcessMessages;
    end;
    CloseFile(f);
  except
  //
  end;
end;

// ----------------------------------------------------------------------------
procedure XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word;
  const AValue: string);
var
  L: Word;
const
  {$J+}
  CXlsLabel: array[0..5] of Word = ($204, 0, 0, 0, 0, 0);
  {$J-}
begin
  try
    L := Length(AValue);
    CXlsLabel[1] := 8 + L;
    CXlsLabel[2] := ARow;
    CXlsLabel[3] := ACol;
    CXlsLabel[5] := L;
    XlsStream.WriteBuffer(CXlsLabel, SizeOf(CXlsLabel));
    XlsStream.WriteBuffer(Pointer(AValue)^, L);
  except
  //
  end;
end;

// ----------------------
function TForm1.SaveAsExcelFile(AGrid: TStringGrid; AFileName: string): Boolean;
const
  {$J+} CXlsBof: array[0..5] of Word = ($809, 8, 00, $10, 0, 0); {$J-}
  CXlsEof: array[0..1] of Word = ($0A, 00);
var
  FStream: TFileStream;
  I, J: Integer;
begin
  Result := False;
  try
    FStream := TFileStream.Create(PChar(AFileName), fmCreate or fmOpenWrite);
    try
      CXlsBof[4] := 0;
      FStream.WriteBuffer(CXlsBof, SizeOf(CXlsBof));
      for i := 0 to AGrid.ColCount - 1 do

//      for j := 0 to AGrid.RowCount - 1 do
        for j := 1 to AGrid.RowCount - 1 do      // Titel niet in XLS

//        XlsWriteCellLabel(FStream, I, J, AGrid.cells[i, j]);
          XlsWriteCellLabel(FStream, I, J-1, AGrid.cells[i, j]);  // Titel niet in XLS

      FStream.WriteBuffer(CXlsEof, SizeOf(CXlsEof));
    Result := True;
    finally
      FStream.Free;
    end;
  except
  //
  end;
end;

// ---Delay--------------------------------------------------------------------
procedure Delay(mS : DWORD);                          // mSec. delay routine
var t1 : DWORD;
begin
  t1 := GetTickCount;
  while (GetTickCount - t1) < mS do Application.ProcessMessages;
end;

// ---Temp Directory-----------------------------------------------------------
function TForm1.GetTempDirectory: String;
var
  TempFolder: array[0..MAX_PATH] of Char;
begin
  GetTempPath(MAX_PATH, @TempFolder);
  Result := StrPas(TempFolder);
end;

// ---Initialisations----------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var   path: array [0..MAX_PATH] of Char;
begin
  POffset := 0;
  TOffset := 0;
  StringGrid1.Colwidths[0]:= 60;
  StringGrid1.Cells[0,0] := 'Nr.';
  StringGrid1.ColWidths[1] := 170;
  StringGrid1.Cells[1,0] := 'Date/Time';
  StringGrid1.ColWidths[2]:= 170;
  StringGrid1.Cells[2,0] := 'Pressure (hPa.)';
  StringGrid1.ColWidths[3]:= 170;
  StringGrid1.Cells[3,0]:='Temperature (C.)';
  if SUCCEEDED(SHGetFolderPath(0, $1A, 0, 0, @path[0])) then
  begin
    If not DirectoryExists(IncludeTrailingBackSlash(Path) + 'PressureSensor') then
      ForceDirectories(IncludeTrailingBackSlash(Path) + 'PressureSensor');
     IniDir := IncludeTrailingBackSlash(Path) + 'PressureSensor';
  end;
  if SUCCEEDED(SHGetFolderPath(0, $05, 0, 0, @path[0])) then
  begin
    If not DirectoryExists(IncludeTrailingBackSlash(Path) + 'PressureSensor') then
      ForceDirectories(IncludeTrailingBackSlash(Path) + 'PressureSensor');
     DataDir := IncludeTrailingBackSlash(Path) + 'PressureSensor';
  end;
  NwChart := False;
//NewCharts;
  DeviceString := GetDeviceString;
  If DeviceString <> '' then
    MyHandle := CreateFile( PChar(DeviceString), GENERIC_READ or GENERIC_WRITE,
                FILE_SHARE_READ or FILE_SHARE_WRITE, Nil, OPEN_EXISTING, 0, 0);
  GetOffsets;
  GetCalibration;
end;

// ---Form Show----------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
var FIni: TIniFile;
    P, T: Double;
    b: Boolean;
    i: Integer;
begin
 { If DeviceString = '' then
  begin
    If Taal = 'Nederlands' then
      MessageBox(Handle, 'Druksensor niet gevonden!',
                         'Geen sensor', MB_OK+MB_IconExclamation)
    else
      MessageBox(Handle, 'Pressure sensor not found!',
                         'No sensor', MB_OK+MB_IconExclamation);
  end; }
  FUsb := TUsbClass.Create;
  FUsb.OnUsbInsertion := UsbIN;
  FUsb.OnUsbRemoval   := UsbOUT;

  FIni := TIniFile.Create(IniDir + '\PressureSensor.ini');
  Form4.SpinEdit1.Value       := FIni.ReadInteger('General', 'Averaging', 5);
  Taal                        := FIni.ReadString ('General', 'Language', 'English');
  ListSaveDir                 := FIni.ReadString ('General', 'ListSaveDir', '');
  Form4.RadioGroup1.ItemIndex := FIni.ReadInteger('General', 'MeasurementInterval', 1);
  PngSaveDir                  := FIni.ReadString ('General', 'PngSaveDir', '');
  Form4.Edit3.Text            := FIni.ReadString ('General', 'PressureDateString', 'Date:');
  Form4.Edit3Change(Self);
  Form4.CheckBox6.Checked     := FIni.ReadBool   ('General', 'PressureGraphAutoScale', False);
  LineColor1                  := FIni.ReadInteger('General', 'PressureGraphColor', clRed);
  Form4.CheckBox4.Checked     := FIni.ReadBool   ('General', 'PressureGraphDotted', False);
  Form4.CheckBox4Click(Self);
  Form4.Edit1.Text            := FIni.ReadString ('General', 'PressureGraphHeader', 'Barometric Pressure (hPa.)');
  Form4.Edit1Change(Self);
  Form4.IntEdit2.Value        := FIni.ReadInteger('General', 'PressureGraphMaxValue', 1100);
  Form4.IntEdit1.Value        := FIni.ReadInteger('General', 'PressureGraphMinValue', 700);
  Form4.CheckBox2.Checked     := FIni.ReadBool   ('General', 'PressureGraphStepped', False);
  Form4.CheckBox2Click(Self);
  Form4.SpinEdit2.Value       := FIni.ReadInteger('General', 'PressureGraphWidth', 1);
  Form4.SpinEdit2Change(Self);
  Slider1.Value               := FIni.ReadInteger('General', 'PressureImageSize', 275);
  Form4.RadioGroup2.ItemIndex := FIni.ReadInteger('General', 'SaveFormat', 0);
  Form4.CheckBox1.Checked     := FIni.ReadBool   ('General', 'Smoothing', True);
  Form4.Edit4.Text            := FIni.ReadString ('General', 'TemperatureDateString', 'Date:');
  Form4.Edit4Change(Self);
  Form4.CheckBox7.Checked     := FIni.ReadBool   ('General', 'TemperatureGraphAutoScale', False);
  LineColor2                  := FIni.ReadInteger('General', 'TemperatureGraphColor', clRed);
  Form4.CheckBox5.Checked     := FIni.ReadBool   ('General', 'TemperatureGraphDotted', False);
  Form4.CheckBox5Click(Self);
  Form4.Edit2.Text            := FIni.ReadString ('General', 'TemperatureGraphHeader', 'Sensor Temperature (C.)');
  Form4.Edit2Change(Self);
  Form4.IntEdit4.Value        := FIni.ReadInteger('General', 'TemperatureGraphMaxValue', 80);
  Form4.IntEdit3.Value        := FIni.ReadInteger('General', 'TemperatureGraphMinValue', -40);
  Form4.CheckBox3.Checked     := FIni.ReadBool   ('General', 'TemperatureGraphStepped', False);
  Form4.Checkbox3Click(Self);
  Form4.SpinEdit3.Value       := FIni.ReadInteger('General', 'TemperatureGraphWidth', 1);
  Form4.SpinEdit3Change(Self);
  Slider2.Value               := FIni.ReadInteger('General', 'TemperatureImageSize', 275);
  b:=                            FIni.ReadBool   ('General', 'VerticalThermometer', False); // 25
  RadioButton1.Checked        := not b;
  RadioButton2.Checked        := b;
  Form2.Edit4.Text            := FIni.ReadString('FTP', 'BarometerName', 'Barometer.png');
  Form2.EdtFtpHost.Text       := FIni.ReadString('FTP', 'Host', '');
  Form2.EdtFtpPassword.Text   := DecodePassword(FIni.ReadString('FTP', 'Password', ''));
  Form2.Edit2.Text            := Fini.ReadString('FTP', 'PressureGraphName', 'Pressure.png');
  Form2.Edit1.Text            := FIni.ReadString('FTP', 'ServerDir', '');
  Form2.Edit3.Text            := FIni.ReadString('FTP', 'TemperatureGraphName', 'Temperature.png' );
  Form2.Edit5.Text            := FIni.ReadString('FTP', 'ThermometerName', 'Thermometer.png');
  Form2.RadioGroup1.ItemIndex := Fini.ReadInteger('FTP', 'UploadInterval', 7 );
  i                           := FIni.ReadInteger('FTP', 'UploadPictures', 0);
  Form2.CheckBox1.Checked := (i and 1 = 1);
  Form2.CheckBox2.Checked := (i and 2 = 2);
  Form2.CheckBox3.Checked := (i and 4 = 4);
  Form2.CheckBox4.Checked := (i and 8 = 8);
  Form2.EdtFtpUser.Text       := FIni.ReadString('FTP', 'User', ''); // 10

  fWunder.Edit2.Text          := DecodePassword(FIni.ReadString('Wunderground', 'Password', ''));
  fWunder.Edit1.Text          := FIni.ReadString('Wunderground', 'StationID', '');
  fWunder.ComboBox1.ItemIndex := FIni.ReadInteger('Wunderground','UploadInterval', 0);

  FIni.Free;

  SetLanguage(Taal);

  If DeviceString = '' then
  begin
    If Taal = 'Nederlands' then
      MessageBox(Handle, 'Druksensor niet gevonden!',
                         'Geen sensor', MB_OK+MB_IconExclamation)
    else
      MessageBox(Handle, 'Pressure sensor not found!',
                         'No sensor', MB_OK+MB_IconExclamation);
  end;

  Startdate := Date2Str(Now);
  If RadioButton1.Checked then
  begin
    Temperature.Visible := True;
    Temperature1.Visible := False;
  end
  else
  begin
    Temperature1.Visible := True;
    Temperature.Visible := False;
  end;

  Slider1Change(Self);
  Slider2Change(Self);

  GetAvgPressureAndTemperature(Form4.SpinEdit1.Value, P, T);
  Pressure.Value := P + POffset;
  Pressure.Caption.Text := FloatToStrF(P + POffset, ffFixed, 5, 1)+ ' hPa.';
  Temperature.Value := T + TOffset;
  Temperature.Caption.Text := FloatToStrF(T + TOffset, ffFixed, 3, 1)+ ' C.';
  If T + TOffset <= 0 then
      Temperature1.Indicator.Color := 4278190335   // Blue
    else
      Temperature1.Indicator.Color := 4294901760;  // Red
  Temperature1.Value := T + TOffset;

  Form4.CheckBox6Click(Self);
  Form4.CheckBox7Click(Self);
  Meten1.Checked := True;

  NewCharts;
end;

// ---Form Close---------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeAndNil(FUsb);
  try
    If MyHandle <> INVALID_HANDLE_VALUE then CloseHandle(MyHandle);
  except
    //
  end;
end;

// ---Form Exit---------------------------------------------------------------
procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

// ---Get Offsets--------------------------------------------------------------
Procedure TForm1.GetOffsets;
var NumBytes: DWord;
begin
  If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
  begin
    WriteFile(MyHandle, bReadFlash, SizeOf(bReadFlash), NumBytes, nil);
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    If Buf[5] <= $80 Then
      POffset := Buf[5] * 0.0625
    else
      POffset := -($100 - Buf[5]) * 0.0625;
    If Buf[6] <= $80 Then
      TOffset := Buf[6] * 0.0625
    else
      TOffset := -($100 -Buf[6]) * 0.0625;
  end;
end;

//---Get Calibration-----------------------------------------------------------
procedure TForm1.GetCalibration;
var NumBytes: DWord;
begin
  If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
  begin
    AvgBuff[0] := 0;
    AvgBuff[1] := 0;
    AvgBuff[2] := 0;
    AvgBuff[3] := 0;
    WriteFile(MyHandle, bReadCal_1, SizeOf(  bReadCal_1), NumBytes, nil);
    Delay(4);
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    AC1 := Buf[1] * $100 + Buf[2];
    AC2 := Buf[3] * $100 + Buf[4];
    AC3 := Buf[5] * $100 + Buf[6];
    AC4 := Buf[7] * $100 + Buf[8];
    WriteFile(MyHandle, bReadCal_2, SizeOf(  bReadCal_2), NumBytes, nil);
    Delay(4);
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    AC5 := Buf[1] * $100 + Buf[2];
    AC6 := Buf[3] * $100 + Buf[4];
    B1  := Buf[5] * $100 + Buf[6];
    B2  := Buf[7] * $100 + Buf[8];
    WriteFile(MyHandle, bReadCal_3, SizeOf(  bReadCal_3), NumBytes, nil);
    Delay(4);
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    MB  := Buf[1] * $100 + Buf[2];
    MC  := Buf[3] * $100 + Buf[4];
    MD  := Buf[5] * $100 + Buf[6];
    Timer1.Enabled := True;
  end;
end;

// ---New Charts---------------------------------------------------------------
procedure TForm1.NewCharts;
begin
  // Save old charts ???
  Chart1.Series[0].Clear;
  Chart2.Series[0].Clear;
  Chart1.Foot.Text.Strings[0] := TRIM(Form4.Edit3.Text) + ' ' + DateToStr(Now);
  Chart2.Foot.Text.Strings[0] := TRIM(Form4.Edit4.Text) + ' ' + DateToStr(Now);

  If Form4.IntEdit2.Value > Form4.IntEdit1.Value then
  begin
    try
      Chart1.LeftAxis.Minimum := Form4.IntEdit1.Value;
      Chart1.LeftAxis.Maximum := Form4.IntEdit2.Value;
    except
    //
    end;
  end
  else 
  begin
   Chart1.LeftAxis.Minimum := 700;
   Chart1.LeftAxis.Maximum := 1100;
  end;

  If Form4.IntEdit4.Value > Form4.IntEdit3.Value then
  begin
    try
      Chart2.LeftAxis.Minimum := Form4.IntEdit3.Value;
      Chart2.LeftAxis.Maximum := Form4.IntEdit4.Value;
    except
    //
    end;
  end
  else
  begin
    Chart2.LeftAxis.Minimum := -40;
    Chart2.LeftAxis.Maximum := 80;
  end;
  NwChart := True;
end;

// ---Save PNG-----------------------------------------------------------------
procedure TForm1.SaveChartAsPng(Chart: TChart; Fn: String);
var  //r: TRect;
   BMP: TBitmap;
   PNG: TPNGObject;
   Tmp: String;
begin
  Tmp := IncludeTrailingBackSlash(GetTempDirectory);
  Chart.SaveToBitmapFile(Tmp + ChangeFileExt(ExtractFileName(Fn), '.bmp'));
  BMP := TBitmap.Create;
  PNG := TPNGObject.Create;
  try
    BMP.LoadFromFile(Tmp + ChangeFileExt(ExtractFileName(Fn), '.bmp'));
    PNG.Assign(BMP);
    PNG.SaveToFile(Fn);
    DeleteFile(Tmp + ChangeFileExt(ExtractFileName(Fn), '.bmp'));
  finally
    PNG.Free;
    BMP.Free;
  end;
end;

// ----------------------------------------------------------------------------
function TForm1.GetDeviceString: String;              // Get MS-DOS devicename
var NumberOfDevices: DWORD;
    i: Integer;
begin
  Result := '';
  FindKnownHidDevices(NumberOfDevices);
  for i := 1 to NumberOfDevices do
  begin
    try
      if (GetVendorID(HidDeviceName[i])  = $0C45) and
         (GetProductID(HidDeviceName[i]) = $7405) then
      begin
        Result := HidDeviceName[i];
        Break;
      end;
    except
      //
    end;
  end;
end;

// ---Timer events-------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
var Hour, Min, Sec, mSec: Word;
    P, T, Vp: Double;
    Tmp, s : String;
    Measure, Upload, DoUnder : Boolean;
begin
  DecodeTime(Now, Hour, Min, Sec, mSec);              // Time to H, M, S
  Timer1.Enabled := False;
  If (Hour = 0) and (Min = 0) then                    // Start of new day
  begin
    if NwChart = False then                           // Chart is not refreshed
    begin
      SaveChartAsPng(Chart1, DataDir+'\'+'P_'+StartDate + '.png');
      SaveChartAsPng(Chart2, DataDir+'\'+'T_'+StartDate + '.png');
      case Form4.RadioGroup2.ItemIndex of
        0: GridToText(DataDir+ '\' + StartDate + '.txt');
        1: GridToCSV(DataDir + '\' + StartDate + '.csv', '"');
        2: SaveAsExcelFile(StringGrid1, DataDir + '\' + StartDate + '.xls');
      end;
      NewCharts;
      EraseList1Click(Self);
      StartDate := DateToStr(Now);
    end;
  end
  else
    NwChart := False;                                 // Not midnight
  // Measurement Interval
  Measure := False;
  Case Form4.RadioGroup1.ItemIndex of
  0: {5 sec}  If Sec mod 5  = 0 then Measure := True;
  1: {10 sec} If Sec mod 10 = 0 then Measure := True;
  2: {20 sec} If Sec mod 20 = 0 then Measure := True;
  3: {30 sec} If Sec mod 30 = 0 then Measure := True;
  4: {1 min}  If (Sec = 0) then Measure := True;
  5: {2 min}  If (Sec = 0) and (Min mod 2 = 0 )then Measure := True;
  6: {5 min}  If (Sec = 0) and (Min mod 5 = 0 )then Measure := True;
  7: {10 min} If (Sec = 0) and (Min mod 10 = 0 )then Measure := True;
  8: {20 min} If (Sec = 0) and (Min mod 20 = 0 )then Measure := True;
  9: {30 min} If (Sec = 0) and (Min mod 30 = 0 )then Measure := True;
  end;
  // Measure
  if Measure then
  begin
    s:= IntToStr(Hour)+'.';
    If Min < 10 then s := s+ '0';
    s:= s + IntToStr(Min)+'.';
    If Sec < 10 then s:=s +'0';
    s := s + IntToStr(Sec);
    GetAvgPressureAndTemperature(Form4.SpinEdit1.Value, P, T);

    // Average last 4 measurements
    AvgBuff[0]:=AvgBuff[1];
    AvgBuff[1]:=AvgBuff[2];
    AvgBuff[2]:=AvgBuff[3];
    AvgBuff[3]:=P;

    If Form4.CheckBox1.Checked then
    begin
      If (AvgBuff[0] = 0) and (AvgBuff[1] = 0) and (AvgBuff[2] = 0) then
        P := AvgBuff[3];
      If (AvgBuff[0] = 0) and (AvgBuff[1] = 0) and (AvgBuff[2] <> 0) then
        P := (AvgBuff[2]+AvgBuff[3])/2;
      If (AvgBuff[0] = 0) and (AvgBuff[1] <> 0) and (AvgBuff[2] <> 0) then
        P := (AvgBuff[1] + AvgBuff[2] + AvgBuff[3]) / 3;
      If (AvgBuff[0] <> 0) and (AvgBuff[1] <> 0) and (AvgBuff[2] <> 0) then
        P := (AvgBuff[0] + AvgBuff[1] + AvgBuff[2] + AvgBuff[3])/4;
    end;

    // Add offsets
    P := P + POffset;
    T := T + TOffset;

    // Update instruments
    Pressure.Value := P;
    Pressure.Caption.Text := FloatToStrF(P, ffFixed, 5, 1)+ ' hPa.';
    Temperature.Value := T;
    Temperature.Caption.Text := FloatToStrF(T, ffFixed, 3, 1)+ ' C.';
    Temperature1.Value := T;

    fWunder.Panel1.Caption := hPAtoBaromin(P);
    fWunder.Panel2.Caption := CtoF(T);

    // Set thermometer color
    If T <= 0 then
      Temperature1.Indicator.Color := 4278190335   // Blue
    else
      Temperature1.Indicator.Color := 4294901760;  // Red

    // Add pressure to Chart 1
    Chart1.Series[0].AddXY(Now, P, '', LineColor1 );
    If Form4.CheckBox6.Checked then
    begin
      try
        Chart1.LeftAxis.Minimum := Chart1.Series[0].MinYValue - 1;
        Chart1.LeftAxis.Maximum := Chart1.series[0].MaxYValue + 1;
      except
      //
      end;
    end;

    // Add temperature to Chart 2
    Chart2.Series[0].AddXY(Now, T, '', LineColor2 );
    If Form4.CheckBox7.Checked then
    begin
      try
        Chart2.LeftAxis.Minimum := Chart2.Series[0].MinYValue - 1;
        Chart2.LeftAxis.Maximum := Chart2.series[0].MaxYValue + 1;
      except
      //
      end;
    end;

    // Update labels in Charts
    Label1.Caption := FloatToStrF(P, ffFixed, 5, 1)+ ' hPa.';
    Label2.Caption := FloatToStrF(T, ffFixed, 3, 1)+ ' C.';

        // Update pressure arrow
    Vp := RoundTo(P, -1);
    If Vp = OldPP then PressureArrow.Picture := ArrowRight.Picture;
    If Vp > OldPP then PressureArrow.Picture := ArrowUp.Picture;
    If Vp < OldPP then PressureArrow.Picture := ArrowDown.Picture;
    OldPP := Vp;

    Vp := RoundTo(T, -1);
    If Vp = OldTT then TemperatureArrow.Picture := ArrowRight.Picture;
    If Vp > OldTT then TemperatureArrow.Picture := ArrowUp.Picture;
    If Vp < OldTT then TemperatureArrow.Picture := ArrowDown.Picture;
    OldTT := Vp;

    // Value to StringGrid
    if StringGrid1.Cells[0,1] <> '' then
      StringGrid1.RowCount := StringGrid1.RowCount + 1;
    StringGrid1.Cells[0, StringGrid1.RowCount-1] := IntToStr(StringGrid1.RowCount-1);
    StringGrid1.Cells[1, StringGrid1.RowCount-1] := DateToStr(Now)+'  '+s;
    StringGrid1.Cells[2, StringGrid1.RowCount-1] := FloatToStrF(P, ffFixed, 5, 1);
    StringGrid1.Cells[3, StringGrid1.RowCount-1] := FloatToStrF(T, ffFixed, 4, 2);
    if Meten1.Checked then
      StringGrid1.Row := StringGrid1.Rowcount -1;
  end;
  // Upload
  Upload := False;
  Case Form2.RadioGroup1.ItemIndex of
  0 : If Sec mod 10 = 0 then Upload := True;
  1 : If Sec mod 20 = 0 then Upload := True;
  2 : If Sec mod 30 = 0 then Upload := True;
  3 : If Sec = 0 then Upload := True;
  4 : If (Sec = 0) and (Min mod 2 = 0) then Upload := True;
  5 : If (Sec = 0) and (Min mod 3 = 0) then Upload := True;
  6 : If (Sec = 0) and (Min mod 4 = 0) then Upload := True;
  7 : If (Sec = 0) and (Min mod 5 = 0) then Upload := True;
  8 : If (Sec = 0) and (Min mod 10 = 0) then Upload := True;
  9 : If (Sec = 0) and (Min mod 20 = 0) then Upload := True;
  10: If (Sec = 0) and (Min mod 30 = 0) then Upload := True;
  11: If (Sec = 0) and (Min = 0) then Upload := True;
  12: If (Sec = 0) and (Min = 0) and (Hour mod 2 = 0) then Upload := True;
  13: If (Sec = 0) and (Min = 0) and (Hour mod 4 = 0) then Upload := True;
  end;
  If Upload then                                      // FTP Upload
  begin
    Tmp := IncludeTrailingBackSlash(GetTempDirectory);// Temp Dir.
    SaveChartAsPng(Chart1, Tmp + Form2.Edit2.Text);   // Pressure chart
    SaveChartAsPng(Chart2, Tmp + Form2.Edit3.Text);   // Temperature chart

    SaveLabInstrumentAsPng(Pressure, Tmp + Form2.Edit4.Text);
    If RadioButton1.Checked then                      // Round thermometer
      SaveLabInstrumentAsPng(Temperature, Tmp + Form2.Edit5.Text)
    else                                              // Vertical thermometer
      SaveLabInstrumentAsPng(Temperature1, Tmp + Form2.Edit5.Text);
    Form2.UploadFile(tmp + Form2.Edit2.text, tmp + Form2.Edit3.text,
                     tmp + Form2.Edit4.text, tmp + Form2.Edit5.text, False);
  end;

  DoUnder := False;
  Case fWunder.ComboBox1.ItemIndex of
  0: ; // Never
  1: If (Sec = 0) and (Min mod 5 = 0) then DoUnder := True;  // 5 min
  2: If (Sec = 0) and (Min mod 10 = 0) then DoUnder := True; // 10 min
  3: If (Sec = 0) and (Min mod 20 = 0) then DoUnder := True; // 20 min
  4: If (Sec = 0) and (Min mod 30 = 0) then DoUnder := True; // 30 min
  5: If (Sec = 0) and (Min = 0) then DoUnder := True;// 1 hour
  6: If (Sec = 0) and (Min = 0) and (hour mod 2 = 0) then DoUnder := True; // 2 hours
  7: If (Sec = 0) and (Min = 0) and (hour mod 3 = 0) then DoUnder := True; // 3 hours
  8: If (Sec = 0) and (Min = 0) and (hour mod 4 = 0) then DoUnder := True; // 4 hours
  9: If (Sec = 0) and (Min = 0) and (hour mod 6 = 0) then DoUnder := True; // 6 hours
  end;
  If DoUnder then fWunder.DoUpload;

  // Enable Timer again
  Timer1.Enabled := True;
end;

//---Get Pressure and Teperature-----------------------------------------------
Procedure TForm1.GetPressureAndTemperature(var Press: Double; var Temp: Double);
var B3, B4, B6, B7: Integer;
    X1, X2, X3: Integer;
    NumBytes: DWord;
    ut, up, p : Integer;
begin
  If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
  begin
    WriteFile(MyHandle, bReadTemp, SizeOf(bReadTemp), NumBytes, nil);
    Delay(2);
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    ut := Buf[1] * $100 + Buf[2];
    bReadPress[4]:= Precision;
    WriteFile(MyHandle, bReadPress, SizeOf(bReadPress), NumBytes, nil);
    Case Precision  of
      0: Delay(5);
      1: Delay(10);
      2: Delay(15);
      3: Delay(27);
    end;
    ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil);
    up := (Buf[1] * $10000 + Buf[2] * $100 + Buf[3]) Shr (8-Precision);
    X1 := ((ut - AC6) * AC5) div $8000;
    X2 := (MC * $800) div (X1 + MD);
    B5 := X1 + X2;
    B6 := B5 - 4000;
    X1 := (B2 * (B6 * B6 div $1000)) div $800;
    X2 := (AC2 * B6) div $800;
    X3 := X1 + X2;
    B3 := ((AC1 * 4 + X3) SHL Precision + 2) div 4;
    X1 := (AC3 * B6) div $2000;
    X2 := (B1 * ((B6 * B6) div $1000)) div $10000;
    X3 := ((X1 + X2) + 2) div 4;
    B4 := AC4 * (X3 + 32768) div $8000;
    B7 := (up - B3) * (50000 SHR Precision);
    If DWord(B7) < $80000000 then
      p := (B7 div B4) * 2
    else
      P := (B7 * 2) div B4;
    X1 := (p div $100) * (p div $100);
    X1 := (X1 * 3038) div $10000;
    X2 := (-7357 * p) div $10000;
    Temp := (B5 + 8) / 160;
    Press:= (p + ((x1 + x2 + 3791) div $10)) / 100;
  end;
end;

// ---Get Avarage Pressure/Temperature-----------------------------------------
Procedure TForm1.GetAvgPressureAndTemperature(Times: Integer; var Press: Double; var Temp: Double);
var P, T: Double;
    i : Integer;
begin
  Press:= 0;
  Temp:= 0;
  for i := 1 to Times do
  begin
    GetPressureAndTemperature(P, T);
    Press := Press + P;
    Temp  := Temp  + T;
  end;
  Press := Press / Times;
  Temp  := Temp  / Times;
end;

// ---USB stick inserted-------------------------------------------------------
procedure TForm1.UsbIN(ASender : TObject; const ADevType,ADriverName,
                       AFriendlyName,  VID, PID : string);
begin
  If (VID='0C45') and (PID='7405') then               // Stick inserted
  begin
    Sleep(1000);                                      // Wait...
    DeviceString := GetDeviceString;                  // Get device string
    If DeviceString <> '' then                        // Device string found
      MyHandle := CreateFile( PChar(DeviceString), GENERIC_READ or GENERIC_WRITE,
                  FILE_SHARE_READ or FILE_SHARE_WRITE, Nil, OPEN_EXISTING, 0, 0);
    GetOffsets;                                       // Read Offsets
    GetCalibration;                                   // Read Calibration
    If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
      Timer1.Enabled := True;                         // (Re)start timer
  end;
end;

// ---USB stick removed--------------------------------------------------------
procedure TForm1.UsbOUT(ASender : TObject; const ADevType,ADriverName,
                        AFriendlyName, VID, PID : string);
begin
  If (VID='0C45') and (PID='7405') then               // Stick removed
  begin
    DeviceString := '';
    Timer1.Enabled := False;                          // Stop timer
    try
      If MyHandle <> INVALID_HANDLE_VALUE then        // Close handle if opened
        CloseHandle(MyHandle);
    except
      //
    end;
  end;
end;

// ---Hardware info------------------------------------------------------------
procedure TForm1.Hardwareinformation1Click(Sender: TObject);
var s: String;
    w: Word;
begin
  If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
  begin
    w := GetVersionNumber(DeviceString);

    If Taal = 'Nederlands' then
    begin
      s := 'Apparaat: ' + GetProductString(DeviceString)+ ' ' +
           IntToStr(w div $100)+'.';
           If w mod $100 < 10 then s:= s + '0';
           s := s + IntToStr(w mod $100) + #13 + #13 +
           'Producent: ' + GetManufacturerString(DeviceString) + #13 + #13 +
           'Serienummer: ' + GetSerialNumberString(DeviceString);
      MessageBox(Handle, PCHAR(s), 'Apparaat info', MB_OK + MB_IconInformation);
    end
    else
    begin
      s := 'Device: ' + GetProductString(DeviceString)+ ' ' +
           IntToStr(w div $100)+'.';
           If w mod $100 < 10 then s:= s + '0';
           s := s + IntToStr(w mod $100) + #13 + #13 +
           'Manufacturer: ' + GetManufacturerString(DeviceString) + #13 + #13 +
           'Serial Number: ' + GetSerialNumberString(DeviceString);
      MessageBox(Handle, PCHAR(s), 'Device info', MB_OK + MB_IconInformation);
    end;
  end
  else
  begin
    If Taal = 'Nederlands' then
      MessageBox(Handle, 'Geen informatie beschikbaar', 'Sensor niet aangesloten', MB_OK + MB_IconStop)
    else
      MessageBox(Handle, 'No information available', 'No sensor connected', MB_OK + MB_IconStop);
  end;
end;

// ---FTP config---------------------------------------------------------------
procedure TForm1.FTPupload1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Calibration1Click(Sender: TObject);
var b: Boolean;
    NumBytes: DWord;
    OldP, OldT: Double;
begin
  b := Timer1.Enabled;
  Timer1.Enabled := False;
  If (DeviceString <> '') and (MyHandle <> INVALID_HANDLE_VALUE) then
  begin
    Form3.FloatEdit1.Value := POffset;
    Form3.FloatEdit2.Value := TOffset;
    OldP := Form3.FloatEdit1.Value;
    OldT := Form3.FloatEdit2.Value;
    Form3.ShowModal;
    If (Form3.FloatEdit1.Value <> OldP) or (Form3.FloatEdit2.Value <> OldT) then
    begin
      If (Form3.FloatEdit1.Value < -7.9) or (Form3.FloatEdit1.Value > 8) or
         (Form3.FloatEdit2.Value < -7.9) or (Form3.FloatEdit2.Value > 8) then
      begin
        MessageBox(Handle, 'Value must be between -7.9 and +8', 'Error',
                   MB_OK + MB_IconStop);
        Timer1.Enabled := b;
        Exit;
      end;
       // Range -7,88 <--> +8,00
      If (Form3.FloatEdit1.Value < 0) Then
        bWriteFlash[5]:= $100 - Round(Abs(Form3.FloatEdit1.Value) * 16)
      else
        bWriteFlash[5] := Round(Form3.FloatEdit1.Value * 16);
      If (Form3.FloatEdit2.Value < 0) Then
        bWriteFlash[6]:= $100 - Round(Abs(Form3.FloatEdit2.Value) * 16)
      else
        bWriteFlash[6] := Round(Form3.FloatEdit2.Value * 16);
      WriteFile(MyHandle, bWriteFlash, SizeOf(bWriteFlash), NumBytes, nil);
      ReadFile(MyHandle, Buf, SizeOf(Buf), NumBytes, nil); // <- Dit is nodig!
      If bWriteFlash[5] <= $80 Then
        POffset := bWriteFlash[5] * 0.0625
      else
        POffset := -($100 - bWriteFlash[5]) * 0.0625;
      If bWriteFlash[6] <= $80 Then
        TOffset := bWriteFlash[6] * 0.0625
      else
        TOffset := -($100 - bWriteFlash[6]) * 0.0625;
    end;
  end
  else
  begin
    If Taal = 'Nederlands' then
      MessageBox(Handle, 'Kan sensor niet calibreren', 'Sensor niet aangesloten', MB_OK+MB_IconStop)
    else
      MessageBox(Handle, 'Can not set calibration', 'No sensor connected', MB_OK+MB_IconStop);
    end;
  Timer1.Enabled := b;
end;

// ----------------------------------------------------------------------------
procedure TForm1.About1Click(Sender: TObject);
begin
  if Taal = 'Nederlands' then
    ShellAbout(Application.MainForm.Handle,
                '- Software voor Barometrische Druk Sensor v '+Version,
                'Copyright  2012-2013 R.T.G. van Steenis',
                Application.Icon.Handle)
  else
    ShellAbout(Application.MainForm.Handle,
                '- Software for Barometric Pressure Sensor v '+Version,
                'Copyright  2012-2013 R.T.G. van Steenis',
                Application.Icon.Handle)
end;

// ----------------------------------------------------------------------------
procedure TForm1.EraseGraph1Click(Sender: TObject);
begin
  NewCharts;
end;

// ----------------------------------------------------------------------------
procedure TForm1.EraseList1Click(Sender: TObject);
var i: Integer;
begin
  StringGrid1.RowCount := 2;
  For i:= 0 to 3 do StringGrid1.Cells[i, 1] := '';
end;

// ----------------------------------------------------------------------------
procedure TForm1.Generalsettings1Click(Sender: TObject);
begin
  Form4.ShowModal;
  If (not Form4.CheckBox6.Checked) and (Form4.IntEdit2.Value > Form4.IntEdit1.Value) then
  begin
    try
      Chart1.LeftAxis.Minimum := Form4.IntEdit1.Value;
      Chart1.LeftAxis.Maximum := Form4.IntEdit2.Value;
    except
    //
    end;
  end;

  If (not Form4.CheckBox7.Checked) and (Form4.IntEdit4.Value > Form4.IntEdit3.Value) then
  begin
    try
      Chart2.LeftAxis.Minimum := Form4.IntEdit3.Value;
      Chart2.LeftAxis.Maximum := Form4.IntEdit4.Value;
    except
    //
    end;
  end;
  
end;

// ----------------------------------------------------------------------------
procedure TForm1.SaveList1Click(Sender: TObject);
begin
  case Form4.RadioGroup2.ItemIndex of
    0: GridToText(DataDir+ '\' + DateToStr(Now) + '.txt');
    1: GridToCSV(DataDir + '\' + DateToStr(Now) + '.csv', '"');
    2: SaveAsExcelFile(StringGrid1, DataDir + '\' + DateToStr(Now) + '.xls');
  end;
end;

// ----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var FIni: TIniFile;
    i: Integer;
begin
  // Save data
  SaveChartAsPng(Chart1, DataDir+'\'+'P_'+StartDate + '.png');
  SaveChartAsPng(Chart2, DataDir+'\'+'T_'+StartDate + '.png');
  case Form4.RadioGroup2.ItemIndex of
    0: GridToText(DataDir+ '\' + StartDate + '.txt');
    1: GridToCSV(DataDir + '\' + StartDate + '.csv', '"');
    2: SaveAsExcelFile(StringGrid1, DataDir + '\' + StartDate + '.xls');
  end;

  // Update INI
  FIni := TIniFile.Create(IniDir + '\PressureSensor.ini');
  FIni.WriteInteger('General', 'Averaging', Form4.SpinEdit1.Value);
  FIni.WriteString ('General', 'Language', Taal);
  FIni.WriteString ('General', 'ListSaveDir', ListSaveDir);
  FIni.WriteInteger('General', 'MeasurementInterval', Form4.RadioGroup1.ItemIndex);
  FIni.WriteString ('General', 'PngSaveDir', PngSaveDir);
  FIni.WriteString ('General', 'PressureDateString', Form4.Edit3.Text);
  FIni.WriteBool   ('General', 'PressureGraphAutoScale', Form4.CheckBox6.Checked);
  FIni.WriteInteger('General', 'PressureGraphColor', LineColor1);
  FIni.WriteBool   ('General', 'PressureGraphDotted', Form4.CheckBox4.Checked);
  FIni.WriteString ('General', 'PressureGraphHeader', Form4.Edit1.Text);
  FIni.WriteInteger('General', 'PressureGraphMaxValue', Form4.IntEdit2.Value);
  FIni.WriteInteger('General', 'PressureGraphMinValue', Form4.IntEdit1.Value);
  FIni.WriteBool   ('General', 'PressureGraphStepped', Form4.CheckBox2.Checked);
  FIni.WriteInteger('General', 'PressureGraphWidth', Form4.SpinEdit2.Value);
  FIni.WriteInteger('General', 'PressureImageSize', Slider1.Value);
  FIni.WriteInteger('General', 'SaveFormat', Form4.RadioGroup2.ItemIndex);
  FIni.WriteBool   ('General', 'Smoothing', Form4.CheckBox1.Checked);
  FIni.WriteString ('General', 'TemperatureDateString', Form4.Edit4.Text);
  FIni.WriteBool   ('General', 'TemperatureGraphAutoScale', Form4.CheckBox7.Checked);
  FIni.WriteInteger('General', 'TemperatureGraphColor', LineColor2);
  FIni.WriteBool   ('General', 'TemperatureGraphDotted', Form4.CheckBox5.Checked);
  FIni.WriteString ('General', 'TemperatureGraphHeader', Form4.Edit2.Text);
  FIni.WriteInteger('General', 'TemperatureGraphMaxValue', Form4.IntEdit4.Value);
  FIni.WriteInteger('General', 'TemperatureGraphMinValue', Form4.IntEdit3.Value);
  FIni.WriteInteger('General', 'TemperatureImageSize', Slider2.Value);
  FIni.WriteInteger('General', 'TemperatureGraphWidth', Form4.SpinEdit3.Value);
  FIni.WriteBool   ('General', 'TemperatureGraphStepped', Form4.CheckBox3.Checked);
  FIni.WriteBool   ('General', 'VerticalThermometer', RadioButton2.Checked); // 25
  // FTP
  FIni.WriteString('FTP', 'BarometerName', Form2.Edit4.Text);
  FIni.WriteString ('FTP', 'Host', Form2.EdtFtpHost.Text);
  FIni.WriteString ('FTP', 'Password', EncodePassword(Form2.EdtFtpPassword.Text));
  Fini.WriteString ('FTP', 'PressureGraphName', Form2.Edit2.Text);
  FIni.WriteString ('FTP', 'ServerDir', Form2.Edit1.Text);
  FIni.WriteString ('FTP', 'TemperatureGraphName', Form2.Edit3.Text);
  FIni.WriteString('FTP', 'ThermometerName', Form2.Edit5.Text);
  Fini.WriteInteger('FTP', 'UploadInterval', Form2.RadioGroup1.ItemIndex);
  i:=0;
  If Form2.CheckBox1.Checked then i:=i + 1;
  If Form2.CheckBox2.Checked then i:=i + 2;
  If Form2.CheckBox3.Checked then i:=i + 4;
  If Form2.CheckBox4.Checked then i:=i + 8;
  FIni.WriteInteger('FTP', 'UploadPictures', i);
  FIni.WriteString ('FTP', 'User', Form2.EdtFtpUser.Text); // 10

  FIni.WriteString('Wunderground', 'Password', EncodePassword(fWunder.Edit2.Text));
  FIni.WriteString('Wunderground', 'StationID', fWunder.Edit1.Text);
  FIni.WriteInteger('Wunderground','UploadInterval', fWunder.ComboBox1.ItemIndex);

  FIni.Free;
end;

// ----------------------------------------------------------------------------
procedure TForm1.SaveGraph1Click(Sender: TObject);
begin
//SaveChartAsPng(Chart1, DataDir+'\'+'P_'+DateToStr(Now) + '.png');
//SaveChartAsPng(Chart2, DataDir+'\'+'T_'+DateToStr(Now) + '.png');
  SaveChartAsPng(Chart1, DataDir+'\'+'P_'+Date2Str(Now) + '.png');
  SaveChartAsPng(Chart2, DataDir+'\'+'T_'+Date2Str(Now) + '.png');
end;

// ----------------------------------------------------------------------------
procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  // Round thermometer
  Temperature1.Visible := False;
  Temperature.Visible := True;
  Slider2Change(Self);
end;

// ----------------------------------------------------------------------------
procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  // Vertical thermometer
  Temperature.Visible := False;
  Temperature1.Visible := True;
  Slider2Change(Self);
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider1Change(Sender: TObject);
begin
  // Size barometer
  If Taal = 'Nederlands' then
  Panel1.caption     := 'Maat: '+ IntToStr(Slider1.Value) + ' x ' +
                                  IntToStr(Slider1.Value) + ' px.'
  else
  Panel1.caption     := 'Size: '+ IntToStr(Slider1.Value) + ' x ' +
                                  IntToStr(Slider1.Value) + ' px.';
  Pressure.Height    := Slider1.Value;
  Pressure.Left      := Tabsheet3.Width div 4 - Pressure.Width div 2;
  Pressure.Width     := Pressure.Height + 1;
  Pressure.Top       := 150 - Pressure.Height div 2;
  Slider1.Update;
  Invalidate;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider1StartTracking(Sender: TObject);
begin
  Panel1.Visible := True;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider1StopTracking(Sender: TObject);
begin
  Panel1.Visible := False;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider2Change(Sender: TObject);
begin
 If Temperature.Visible then
  begin
    If Taal = 'Nederlands' then
    Panel2.Caption     := 'Maat: '+ IntToStr(Slider2.Value) + ' x ' +
                                    IntToStr(Slider2.Value) + ' px.'
    else
    Panel2.Caption     := 'Size: '+ IntToStr(Slider2.Value) + ' x ' +
                                    IntToStr(Slider2.Value) + ' px.';
    Temperature.Height := Slider2.Value;
    Temperature.Width  := Temperature.Height + 1;
    Temperature.Left   := 3 * (Tabsheet3.Width div 4) - Temperature.Width div 2;
    Temperature.Top    := 150 - Temperature.Height div 2;
  end
  else
  begin
    Panel2.Caption     := 'Size: '+ IntToStr(Slider2.Value) + ' x ' +
                                    IntToStr(Slider2.Value div 3 + 1) + ' px.';
    Temperature1.Height := Slider2.Value;
    Temperature1.Width  := Temperature1.Height div 3 + 1;
    Temperature1.Left   := 3 * (Tabsheet3.Width div 4) - Temperature1.Width div 2;
    Temperature1.Top    := 150 - Temperature1.Height div 2;
  end;
  Slider2.Update;
  Invalidate;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider2StartTracking(Sender: TObject);
begin
  Panel2.Visible := True;
end;

// ----------------------------------------------------------------------------
procedure TForm1.Slider2StopTracking(Sender: TObject);
begin
  Panel2.Visible := False;
end;

// ----------------------------------------------------------------------------
procedure TForm1.WeatherUnderground1Click(Sender: TObject);
begin
  fWunder.ShowModal;
end;

procedure TForm1.Options1Click(Sender: TObject);
begin
  If Taal = 'Nederlands' then
    Nederlands1.Checked := True
  else
    Engels1.Checked := True;
end;

procedure TForm1.Nederlands1Click(Sender: TObject);
begin
  Taal := 'Nederlands';
  SetLanguage(Taal);
end;

procedure TForm1.Engels1Click(Sender: TObject);
begin
  Taal := 'English';
  SetLanguage(Taal);
end;

procedure TForm1.Files1Click(Sender: TObject);
begin
 If DirectoryExists(DataDir) then
   ShellExecute(Handle, 'open', 'Explorer', PCHAR(DataDir), '', SW_ShowNormal);
end;

procedure TForm1.SavePressureGraphas1Click(Sender: TObject);
begin
  If DirectoryExists(PngSaveDir) then
    SaveDialogEx1.InitialDir := PngSaveDir;
  SaveDialogEx1.DefaultExt:= 'png';
  if Taal = 'Nederlands' then
  begin
    SaveDialogEx1.Filter := 'PNG bestanden (*.png)|*.png';
    SaveDialogEx1.Title  := 'Druk grafiek opslaan';
  end
  else
  begin
    SaveDialogEx1.Filter := 'PNG files (*.png)|*.png';
    SaveDialogEx1.Title  := 'Save pressure graph';
  end;
  If (SaveDialogEx1.Execute) and (SaveDialogEx1.Filename <> '' ) then
  begin
    PngSaveDir := ExtractFilePath(SaveDialogEx1.Filename);
    SaveChartAsPng(Chart1, SaveDialogEx1.Filename);
  end;
end;

procedure TForm1.SaveTemperatureGraphas1Click(Sender: TObject);
begin
  If DirectoryExists(PngSaveDir) then
    SaveDialogEx1.InitialDir := PngSaveDir;
  SaveDialogEx1.DefaultExt:= 'png';  
  if Taal = 'Nederlands' then
  begin
    SaveDialogEx1.Filter := 'PNG bestanden (*.png)|*.png';
    SaveDialogEx1.Title  := 'Temperatuur grafiek opslaan';
  end
  else
  begin
    SaveDialogEx1.Filter := 'PNG files (*.png)|*.png';
    SaveDialogEx1.Title  := 'Save temperature graph';
  end;
  If (SaveDialogEx1.Execute) and (SaveDialogEx1.Filename <> '' ) then
  begin
    PngSaveDir := ExtractFilePath(SaveDialogEx1.Filename);
    SaveChartAsPng(Chart2, SaveDialogEx1.Filename);
  end;
end;

procedure TForm1.SaveListas1Click(Sender: TObject);
begin
  If DirectoryExists(ListSaveDir) then
    SaveDialogEx1.InitialDir := ListSaveDir;
  If Taal = 'Nederlands' then
    SaveDialogEx1.Title := 'Lijst opslaan'
  else
    SaveDialogEx1.Title := 'Save List';
  Case Form4.RadioGroup2.ItemIndex of
  0: begin
       SaveDialogEx1.DefaultExt := 'txt';
       if Taal = 'Nederlands' then
         SaveDialogEx1.Filter := 'Tekst bestanden (*.txt)|*.txt'
       else
         SaveDialogEx1.Filter := 'Text files (*.txt)|*.txt';
     end;
  1: begin
       SaveDialogEx1.DefaultExt := 'csv';
       If Taal = 'Nederlands' then
         SaveDialogEx1.Filter := 'Komma gescheiden tekst (*.csv)|*.csv'
       else
         SaveDialogEx1.Filter := 'Comma separated text (*.csv)|*.csv';
     end;
  2: begin
       SaveDialogEx1.DefaultExt := 'xls';
       If Taal = 'Nederlands' then
         SaveDialogEx1.Filter := 'Excel bestanden (*.xls)|*.xls'
       else
         SaveDialogEx1.Filter := 'Excel files (*.xls)|*.xls';
     end;
  end;
  If (SaveDialogEx1.Execute) and (SaveDialogEx1.FileName <> '') then
  begin
    ListSaveDir := ExtractFilePath(SaveDialogEx1.FileName);
    case Form4.RadioGroup2.ItemIndex of
      0: GridToText(SaveDialogEx1.Filename);
      1: GridToCSV(SaveDialogEx1.Filename, '"');
      2: SaveAsExcelFile(StringGrid1, SaveDialogEx1.Filename);
    end;
  end;  
end;

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
  Chart1.UndoZoom;
end;

procedure TForm1.Chart2DblClick(Sender: TObject);
begin
  Chart2.UndoZoom;
end;

procedure TForm1.Pauze1Click(Sender: TObject);
begin
 Pauze1.Checked := True;
end;

procedure TForm1.Meten1Click(Sender: TObject);
begin
  Meten1.Checked := True;
end;

end.



