unit HotLabel;
interface

uses  Windows, Messages, SysUtils, Controls, Forms, Graphics, Dialogs,
      Classes, StdCtrls;

type
  THotLabel = class(TLabel)
  private
  protected
    FColorLeave : TColor;
    FColorEnter : TColor;
    FDoUnderLine  : Boolean;
   public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    procedure CMMouseEnter(var Msg: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Msg: TMessage); message CM_MOUSELEAVE;
    procedure SetColorLeave(aVal : TColor);
  published
   property ColorLeave : TColor read FColorLeave write SetColorLeave;
   property ColorEnter : TColor read FColorEnter write FColorEnter;
   property UnderLine: Boolean read FDoUnderLine write FDoUnderLine;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [THotLabel]);
end;

//==========================================================================
constructor THotLabel.Create(aOwner:TComponent);
//==========================================================================
begin
  inherited Create(aOwner);
  Font.Name := 'Arial';
  Font.Color := clblack;
  FDoUnderLine:= False;
end;

//==========================================================================
procedure THotLabel.CMMouseEnter(var Msg: TMessage);
//==========================================================================
begin
 if FDoUnderLine=True then Font.Style:=[fsUnderLine];
 font.color := FColorEnter;
end;

//==========================================================================
procedure THotLabel.CMMouseLeave(var Msg: TMessage);
//==========================================================================
begin
  Font.Style:=[];
  font.color := FColorLeave;
end;

//==========================================================================
procedure THotLabel.SetColorLeave(aVal : TColor);
//==========================================================================
begin
  FColorLeave := aVal;
  font.color := aVal;
end;

end.
