unit FTPconfig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, WinInet, Gauges, Language;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edtFtpPassword: TEdit;
    edtFtpUser: TEdit;
    EdtFtpHost: TEdit;
    Button1: TButton;
    FTPstatusPanel: TPanel;
    Edit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    RadioGroup1: TRadioGroup;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UploadFile(File1, File2, File3, File4 : String; Test: Boolean);
  end;

var
  Form2: TForm2;

implementation

uses Chart_pas;

{$R *.DFM}

procedure TForm2.UploadFile(File1, File2, File3, File4 : String; Test: Boolean);
const BUFFERSIZE = 8192;
      // Directory op FTP server
      // Host='home.telfort.nl';                      // Inlog-Hostname
      // User='r.vansteenis-t@telfort.nl';            // Inlog-UserName
      // Pass='P6XABWyr';                             // Inlog-PassWord
var   hNet, hFTP, hFile: HINTERNET;
      Buffer: Array[0..BUFFERSIZE - 1] of Char;
      Bufsize, BytesWritten: DWORD;
      LocalFile: file;
begin
  // Nothing to do!
  If (not Test) and ((not CheckBox1.Checked) and (not CheckBox2.Checked) and
                     (not CheckBox3.Checked) and (not CheckBox4.Checked)) then Exit;
  // Inlog details not complete
  If (edtFTPhost.text='') or
     (EdtFTPuser.text='') or
     (EdtFTPpassword.text='') then Exit;              // FTP gegevens niet compleet

  hNet   := InternetOpen(PChar(''),                   // Internet verbinding
                        INTERNET_OPEN_TYPE_PRECONFIG,
                        nil,
                        nil,
                        0);
  if hNet = nil then
  begin
    If Taal = 'Nederlands' then
      FTPstatusPanel.Caption:='Kan geen internet verbinding maken'
    else
      FTPstatusPanel.Caption:='Can not connect to the internet';
    Exit;                                             // Geen verbinding
  end;
  hFTP   := InternetConnect(hNet,                     // Account inlog
                           PChar(TRIM(EdtFTPhost.Text)),
                           INTERNET_DEFAULT_FTP_PORT,
                           PChar(TRIM(EdtFTPuser.Text)),
                           PChar(Trim(EdtFTPpassword.Text)),
                           INTERNET_SERVICE_FTP,
                           INTERNET_FLAG_PASSIVE,
                           0);
  if hFTP = nil then                                  // Inlog mislukt
  begin
    InternetCloseHandle(hNet);
    if Taal = 'Nederlands' then
      FTPstatusPanel.Caption:='Geen FTP toegang'
    else
      FTPstatusPanel.Caption:='No FTP access';
    Exit;
  end;

  If Taal = 'Nederlands' then
    FTPstatusPanel.Caption:='Internet verbinding OK'
  else
    FTPstatusPanel.Caption:='Internet connection OK';

  ftpSetCurrentDirectory(hFTP, '/');                  // Root directory op server

  if TRIM(Edit1.Text) <> '' then
  begin
    if FtpSetCurrentDirectory(hFTP, PChar(TRIM(Edit1.Text)))=False then // Ga naar Dir.Naam
    begin                                               // Dir. bestaat niet
      If FtpCreateDirectory(hFTP, PChar(TRIM(Edit1.Text)))=True then    // Maak Dir.Naam.
        FtpSetCurrentDirectory(hFTP, PChar(TRIM(Edit1.Text)))      // Ga naar /Dir.Naam
      else
      begin
        If Taal = 'Nederlands' then
          FTPstatusPanel.Caption:='ChangeDir mislukt'
        else
          FTPstatusPanel.Caption:='ChangeDir failed';
        Exit;
      end;
    end;
  end;


  If Test then
  begin
    InternetCloseHandle(hFTP);
    InternetCloseHandle(hNet);
    if Taal = 'Nederlands' then
      MessageBox(Handle, 'FTP instellingen zijn correct', 'FTP upload OK', MB_OK+MB_IconInformation)
    else
      MessageBox(Handle, 'FTP settings are correct', 'FTP upload OK', MB_OK+MB_IconInformation);
    Exit;
  end;

  if (CheckBox1.Checked) and (FileExists(File1)) then
  begin
    hFile := FtpOpenFile(hFTP,                          // Doelfile op server
                         PChar(Edit2.Text),             // Filenaam maken
                         GENERIC_WRITE,
                         FTP_TRANSFER_TYPE_BINARY,
                         0);
    if hFile = nil then                                 // Kan file niet maken
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      If Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan FTP file niet aanmaken'
      else
        FTPstatusPanel.Caption:='Can not create FTP file';
      Exit;
    end;
    AssignFile(LocalFile, File1);                       // File openen
    {$i-}
    Reset(LocalFile, 1);
    {$i+}
    if IOResult <> 0 then                               // File is niet geopend
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      if Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan lokaal bestand niet openen'
      else
        FTPstatusPanel.Caption:='Can not open local file';
      Exit;
    end;
    If Taal = 'Nederlands' then
      FTPstatusPanel.Caption:='Uploaden bestand '+ ExtractFileName(File1)
    else
      FTPstatusPanel.Caption:='Uploading file '+ ExtractFileName(File1);
    repeat                                              // File uploaden
      Application.ProcessMessages;
      BlockRead(LocalFile, Buffer, SizeOf(Buffer), BufSize);
      if not InternetWriteFile(hFile,
                               @buffer,
                               BufSize,
                               BytesWritten) then Break;
    until (BufSize = 0) or (BufSize <> BytesWritten);   // Uploaden klaar
    CloseFile(LocalFile);                               // Sluit file
    InternetCloseHandle(hFile);                         // Sluit internet verbinding
  end;

  if (CheckBox2.Checked) and (FileExists(File2)) then
  begin
    hFile := FtpOpenFile(hFTP,                          // Doelfile op server
                         PChar(Edit3.Text),             // Filenaam maken
                         GENERIC_WRITE,
                         FTP_TRANSFER_TYPE_BINARY,
                         0);
    if hFile = nil then                                 // Kan file niet maken
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      If Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan FTP bestand niet aanmaken'
      else
        FTPstatusPanel.Caption:='Can not create FTP file';
      Exit;
    end;
    AssignFile(LocalFile, File2);                      // File openen
    {$i-}
    Reset(LocalFile, 1);
    {$i+}
    if IOResult <> 0 then                               // File is niet geopend
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      if Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan lokaal bestand niet openen'
      else
        FTPstatusPanel.Caption:='Can not open local file';
      Exit;
    end;
    FTPstatusPanel.Caption:='Uploading file '+ ExtractFileName(File2);
    repeat                                              // File uploaden
      Application.ProcessMessages;
      BlockRead(LocalFile, Buffer, SizeOf(Buffer), BufSize);
      if not InternetWriteFile(hFile,
                               @buffer,
                               BufSize,
                               BytesWritten) then Break;
     until (BufSize = 0) or (BufSize <> BytesWritten);   // Uploaden klaar
     CloseFile(LocalFile);                               // Sluit file
    InternetCloseHandle(hFile);                          // Sluit internet verbinding
  end;

  if (CheckBox3.Checked) and (FileExists(File3)) then
  begin
    hFile := FtpOpenFile(hFTP,                          // Doelfile op server
                         PChar(Edit4.Text),             // Filenaam maken
                         GENERIC_WRITE,
                         FTP_TRANSFER_TYPE_BINARY,
                         0);
    if hFile = nil then                                 // Kan file niet maken
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      If Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan FTP bestand niet aanmaken'
      else
        FTPstatusPanel.Caption:='Can not create FTP file';
      Exit;
    end;
    AssignFile(LocalFile, File3);                      // File openen
    {$i-}
    Reset(LocalFile, 1);
    {$i+}
    if IOResult <> 0 then                               // File is niet geopend
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      if Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan lokaal bestand niet openen'
      else
        FTPstatusPanel.Caption:='Can not open local file';
      Exit;
    end;
    If Taal = 'Nederlands' then
      FTPstatusPanel.Caption:='Uploaden bestand '+ ExtractFileName(File3)
    else
      FTPstatusPanel.Caption:='Uploading file '+ ExtractFileName(File3);
    repeat                                              // File uploaden
      Application.ProcessMessages;
      BlockRead(LocalFile, Buffer, SizeOf(Buffer), BufSize);
      if not InternetWriteFile(hFile,
                               @buffer,
                               BufSize,
                               BytesWritten) then Break;
     until (BufSize = 0) or (BufSize <> BytesWritten);   // Uploaden klaar
     CloseFile(LocalFile);                               // Sluit file
    InternetCloseHandle(hFile);                          // Sluit internet verbinding
  end;

  if (CheckBox4.Checked) and (FileExists(File4)) then
  begin
    hFile := FtpOpenFile(hFTP,                          // Doelfile op server
                         PChar(Edit5.Text),             // Filenaam maken
                         GENERIC_WRITE,
                         FTP_TRANSFER_TYPE_BINARY,
                         0);
    if hFile = nil then                                 // Kan file niet maken
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      If Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan FTP bestand niet aanmaken'
      else
        FTPstatusPanel.Caption:='Can not create FTP file';
      Exit;
    end;
    AssignFile(LocalFile, File4);                      // File openen
    {$i-}
    Reset(LocalFile, 1);
    {$i+}
    if IOResult <> 0 then                               // File is niet geopend
    begin
      InternetCloseHandle(hFTP);
      InternetCloseHandle(hNet);
      if Taal = 'Nederlands' then
        FTPstatusPanel.Caption:='Kan lokaal bestand niet openen'
      else
        FTPstatusPanel.Caption:='Can not open local file';
      Exit;
    end;
    If Taal = 'Nederlands' then
      FTPstatusPanel.Caption:='Uploaden bestand '+ ExtractFileName(File4)
    else
      FTPstatusPanel.Caption:='Uploading file '+ ExtractFileName(File4);
    repeat                                              // File uploaden
      Application.ProcessMessages;
      BlockRead(LocalFile, Buffer, SizeOf(Buffer), BufSize);
      if not InternetWriteFile(hFile,
                               @buffer,
                               BufSize,
                               BytesWritten) then Break;
     until (BufSize = 0) or (BufSize <> BytesWritten);   // Uploaden klaar
     CloseFile(LocalFile);                               // Sluit file
    InternetCloseHandle(hFile);                          // Sluit internet verbinding
  end;
  If Taal = 'Nederlands' then
    FTPstatusPanel.Caption:='Internet verbinding gesloten'
  else
    FTPstatusPanel.Caption:='Closed Internet connection';
  InternetCloseHandle(hFTP);
  InternetCloseHandle(hNet);
end;

procedure TForm2.Button1Click(Sender: TObject);
var b: Boolean;
begin
  If (edtFtpHost.Text='') or (edtFtpUser.Text='') or (edtFtpPassword.Text='') then
  begin
    if Taal = 'Nederlands' then
      MessageBox(Handle, 'A.u.b. alle velden invullen!', 'Informatie ontbreekt',
                 MB_OK+MB_IconStop)
    else
      MessageBox(Handle, 'Please fill all fields!', 'Information is missing',
                 MB_OK+MB_IconStop);
    Exit;
  end;
  b := Form1.Timer1.Enabled;
  Form1.Timer1.Enabled := False;
  UploadFile('', '', '', '', True);
  Form1.Timer1.Enabled := b;
end;

end.
