unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, RtColorPicker, Chart, Series, NumEdit;

type
  TForm4 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    SpinEdit2: TSpinEdit;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    ColorPickCombo2: TColorPickCombo;
    SpinEdit3: TSpinEdit;
    ColorPickCombo1: TColorPickCombo;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    IntEdit1: TIntEdit;
    IntEdit2: TIntEdit;
    IntEdit3: TIntEdit;
    IntEdit4: TIntEdit;
    Label13: TLabel;
    Label14: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure ColorPickCombo1Changed(Sender: TObject);
    procedure ColorPickCombo2Changed(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure SpinEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetGraphColor(Graph: TChart; Color: TColor);
  public
    { Public declarations }
  end;

var
  Form4: TForm4;
  LineColor1 : TColor= clRed;
  LineColor2 : TColor= clBlue;

implementation

uses Chart_pas;

{$R *.DFM}
// ----------------------------------------------------------------------------
procedure TForm4.SetGraphColor(Graph: TChart; Color: TColor);
var i: Integer;
begin
 for i:= 0 to Graph.SeriesList[0].Count-1 do
   Graph.SeriesList[0].ValueColor[i]:=Color;
 If Graph = Form1.Chart1 then
   LineColor1 := Color
 else
   LineColor2 := Color;
end;

procedure TForm4.FormActivate(Sender: TObject);
begin
  ColorPickCombo1.ActiveColor := LineColor1;
  ColorPickCombo2.ActiveColor := LineColor2;
end;

procedure TForm4.ColorPickCombo1Changed(Sender: TObject);
begin
  LineColor1 := ColorPickCombo1.ActiveColor;
  SetGraphColor(Form1.Chart1, LineColor1);
end;

procedure TForm4.ColorPickCombo2Changed(Sender: TObject);
begin
  LineColor2 := ColorPickCombo2.ActiveColor;
  SetGraphColor(Form1.Chart2, LineColor2);
end;

procedure TForm4.SpinEdit2Change(Sender: TObject);
begin
  (Form1.Chart1[0] as TLineSeries).LinePen.Width := SpinEdit2.Value;
end;

procedure TForm4.SpinEdit3Change(Sender: TObject);
begin
  (Form1.Chart2[0] as TLineSeries).LinePen.Width := SpinEdit3.Value;
end;

procedure TForm4.CheckBox2Click(Sender: TObject);
begin
  (Form1.Chart1[0] as TLineSeries).Stairs := CheckBox2.Checked;
end;

procedure TForm4.CheckBox3Click(Sender: TObject);
begin
  (Form1.Chart2[0] as TLineSeries).Stairs := CheckBox3.Checked;
end;

procedure TForm4.CheckBox4Click(Sender: TObject);
begin
  (Form1.Chart1[0] as TLineSeries).Pointer.Visible := CheckBox4.Checked;
  (Form1.Chart1[0] as TLineSeries).Pointer.HorizSize := 4;
  (Form1.Chart1[0] as TLineSeries).Pointer.VertSize := 4;
end;

procedure TForm4.CheckBox5Click(Sender: TObject);
begin
  (Form1.Chart2[0] as TLineSeries).Pointer.Visible := CheckBox5.Checked;
  (Form1.Chart2[0] as TLineSeries).Pointer.HorizSize := 4;
  (Form1.Chart2[0] as TLineSeries).Pointer.VertSize := 4;
end;

procedure TForm4.Edit1Change(Sender: TObject);
begin
  Form1.Chart1.Title.Text[0]:=Edit1.Text;
end;

procedure TForm4.Edit2Change(Sender: TObject);
begin
  Form1.Chart2.Title.Text[0]:=Edit2.Text;
end;

procedure TForm4.Edit3Change(Sender: TObject);
begin
  Form1.Chart1.Foot.Text.Strings[0] := TRIM(Edit3.Text) + ' ' + DateToStr(Now);
end;

procedure TForm4.Edit4Change(Sender: TObject);
begin
  Form1.Chart2.Foot.Text.Strings[0] := TRIM(Edit4.Text) + ' ' + DateToStr(Now);
end;

procedure TForm4.SpinEdit2KeyPress(Sender: TObject; var Key: Char);
begin
 Key := #0;
end;

procedure TForm4.CheckBox6Click(Sender: TObject);
begin
  IntEdit1.Enabled := not CheckBox6.Checked;
  IntEdit2.Enabled := not CheckBox6.Checked;
  If (CheckBox6.Checked) and (Form1.Chart1.SeriesList[0].Count > 0 ) then
  begin
    try
      Form1.Chart1.LeftAxis.Minimum := Form1.Chart1.Series[0].MinYValue - 1;
      Form1.Chart1.LeftAxis.Maximum := Form1.Chart1.series[0].MaxYValue + 1;
    except
    //
    end; 
  end
  else
  begin
    If IntEdit2.Value > IntEdit1.Value then
    begin
      try
        Form1.Chart1.LeftAxis.Minimum := IntEdit1.Value;
        Form1.Chart1.LeftAxis.Maximum := IntEdit2.Value;
      except
      //
      end;
    end;
  end;
end;

procedure TForm4.CheckBox7Click(Sender: TObject);
begin
  IntEdit3.Enabled := not CheckBox7.Checked;
  IntEdit4.Enabled := not CheckBox7.Checked;
  if (CheckBox7.Checked) and (Form1.Chart2.Series[0].Count > 0) then
  begin
    try
      Form1.Chart2.LeftAxis.Minimum := Form1.Chart2.Series[0].MinYValue - 1;
      Form1.Chart2.LeftAxis.Maximum := Form1.Chart2.series[0].MaxYValue + 1;
    except
    //
    end;
  end
  else
  begin
    If IntEdit4.Value > IntEdit3.Value then
    begin
      try
        Form1.Chart2.LeftAxis.Minimum := IntEdit3.Value;
        Form1.Chart2.LeftAxis.Maximum := IntEdit4.Value;
      except
      //
      end;
    end;
  end;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  If PixelsPerInch > 96 then
    Font.Size := 7;
end;

end.
